# Secret Base!
 
## Description
My application is the application use for search the anime. User can view the
anime information by search by the title or genre etc.
User can also view some graph.

## Data Sources
https://www.kaggle.com/datasets/andreuvallhernndez/myanimelist?resource=download&select=anime.csv
 
## Running the Application
I use these 8 package
- tkinter <br>
- PIL v.9.5.0 <br>
- requests v.2.28.2 <br>
- ast v.2.12.12 <br>
- matplotlib v.3.7.1 <br>
- numpy v.1.23.2 <br>
- pandas v.2.0.0 <br>
 
## Design
### Class Describe
* #### Main: This class call pages class and display for User.
* #### Pages: This class manage the overall GUI, manage widgets and it's function.
* #### Csv_reader: This class is for read the dataframe from csv file then return dataframe.
 ![alt text](picture/Classdiagram.png)
 ![alt text](picture/Sequence diagram.png)

## Design Patterns Used
I use facade pattern implement in my code. in presentation layer I have Main class calling page for display. in Domain layer, I have Pages class for display and do the GUI, <br>
also do the widget and their function. in the infrastructure layer, I have Csv_reader class for loading and return dataframe.
 
## Graph Algorithm Used
 ![alt text](picture/networkgraph.png)
Graph problems : 
- Vertices are Anime title ( I choose top 10 anime for easy to observe)
- Edges are the genre's similarities and differences. 
- The Edges have weights that represent the similarity of the anime. The less number, the more similarity of the genres. 
- Graph problem : Shortest path from the initial anime A to the Terminal anime B. 
- I use non-negative Dijkstra’s algorithm to solve the problem from the initial anime A. 
- The output is the list of the anime from anime A to B. 
- The running time of the algorithm is O(V + E)
- The running time to build the graph is O(n2)
 
## Other Information
- I provide light mode to change the background color.

